#include <osbind.h>
#include <stdio.h>
#include <sys/syslog.h>
#include "lpr.h"

void print(job,copy)
long job;
int  copy;
{
	FILE	*fd,*cd;
	char	*buff;
	char	path[132];
	Lpr_h	hd;
	Lpr_d	dt;
	int 	anz, bread;

	sprintf(path,"u:\\var\\spool\\A%ld",job);
	openlog("lpd", 0, LOG_LPR);
	if ((fd=fopen(path,"r")) == (FILE *)0) {
		syslog(LOG_ERR, "can't open spool-file %s",path);
		closelog();
		return;
	}
	if ((cd = fopen( DEVNAME, "w")) == (FILE *)0) {
		syslog(LOG_ERR, "can't open %s", DEVNAME);
		closelog();
		return;
	}
	if ( !(buff = (char *) Malloc( BUFSIZE))) {
		syslog(LOG_ERR,"not enough memory for printbuffer");
		closelog();
		return;
	}
	for (anz = 1; anz <= copy; anz++) {
		rewind(fd);
		do {
			bread = fread( buff, 1, BUFSIZE, fd);
			fwrite( buff, 1, bread, cd);
		} while ( bread == BUFSIZE);
	}
	Mfree( buff);
	fclose(cd);
	fclose(fd);
	unlink(path);
	get_semaphore();
	if ((fd = fopen(LPRSTAT,"rb")) == (FILE *)0) {
		syslog(LOG_ERR,"can't open LPRSTAT");
		closelog();
		exit(-1);
	}
	if ((cd = fopen(LPRCP,"wb")) == (FILE *)0) {
		syslog(LOG_ERR,"can't open LPRCP");
		closelog();
		exit(-1);
	}
	fread(&hd,sizeof(Lpr_h),1,fd);
	fwrite(&hd,sizeof(Lpr_h),1,cd);
	for (;;) {
		if (fread(&dt,sizeof(Lpr_d),1,fd) != 1) break;
		fwrite(&dt,sizeof(Lpr_d),1,cd);
	}
	fclose(fd);
	fclose(cd);
	if ((fd = fopen(LPRSTAT,"wb")) == (FILE *)0) {
		syslog(LOG_ERR,"can't open LPRSTAT");
		closelog();
		free_semaphore();
		return;
	}
	if ((cd = fopen(LPRCP,"rb")) == (FILE *)0) {
		syslog(LOG_ERR,"can't open LPRCP");
		closelog();
		fclose(fd);
		free_semaphore();
		return;
	}
	closelog();
	fread(&hd,sizeof(hd),1,cd);
	fwrite(&hd,sizeof(hd),1,fd);
	for (;;) {
		if (fread(&dt,sizeof(dt),1,cd) != 1) break;
		if (dt.job == job) {
			continue;
		}
		fwrite(&dt,sizeof(dt),1,fd);
	}
	fclose(fd);
	fclose(cd);
	unlink(LPRCP);
	free_semaphore();
}
