#include <stdio.h>
#include "lpr.h"
#define SEMA     "u:\\var\\spool\\lprsema"

void get_semaphore( void)
{
  FILE *fd,*err;

  for (;;)
      {
         if ((fd = fopen(SEMA,"r")) == (FILE *)0) 
            {
              if ((fd = fopen(SEMA,"w")) == (FILE *)0)
                 {
                   err = fopen(LPRMESS,"a");
                   fprintf(err,"sema: can't open lockfile\n");
                   fclose(err);
                   exit(-1);
                 }
	      fclose(fd);
	      return;
            }
         fclose(fd);
         sleep(2);   /* wait 2 seconds..... */
       }
}

void free_semaphore( void)
{
  unlink(SEMA);
}

void create_semaphore( void)
{
  get_semaphore();
}

void destroy_semaphore( void)
{
  free_semaphore();
}
